#include <time.h>

void EasterSun();

main(ac, av)
char **av;
{
	if (ac <= 1) {
		time_t t = time((time_t *)0);
		struct tm *tm = localtime(&t);

		EasterSun(tm->tm_year + 1900);
		exit(0);
	}
	for(; ac > 1; ac--, av++)
		EasterSun(atoi(av[1]));
	exit(0);
}

/*
 * Easter Sundays are computed from a formula give by Jean Meeus, in
 * "Astronomical Formulae for Calculators", published by Willman-Bell Inc.,
 * 1988.  According to Meeus, the "Journal of the British Astronomical
 * Association", published the same formula in December, 1977, and Meeus
 * also cites an earlier reference, the book "General Astronomy",
 * by Spencer Jones, written in 1922, no publisher given.
 */

void
EasterSun (Y)
int Y;
{
	int a, b, c, d, e, f, g, h, i, j, k, m, n;

	a = Y % 19;
	j = Y % 4;
	m = 0;
	if (Y > 1582) {
		b = Y / 25 >> 2;
		c = Y % 100;
		d = b >> 2;
		e = b % 4;
		f = (b + 8) / 25;
		g = (b - f + 1) / 3;
		h = (19 * a + b - d - g + 15) % 30;
		i = c >> 2;
		k = (32 + 2 * e + 2 * i - h - j) % 7;
		m = (a + 11 * h + 22 * k) / 451;
	} else {
		b = Y % 7;
		h = (19 * a + 15) % 30;
		k = (2 * j + 4 * b - h + 34) % 7;
	}
	n = h + k - 7 * m + 21;
	printf(" %.4d:%s %2d\n", Y, n / 31 ? "April" : "March", n % 31 + 1);
}
